program cComp;

(*
//  C-to-Quadcode Compiler
//  ----------------------
//  Practical Work:
//      Compilers Summer Semester 2008
//      (Lecture by Mr. Schwinn)
//
//  Course:
//      TAI-06-ABC
//
//  Developers:
//     Kevin Niehage   (Matrikelnummer: 280888)
//     Michaela Hansel (Matrikelnummer: 221664)
*)

// IMPLEMENTATION STATUS: DONE
{$APPTYPE CONSOLE}

uses
  SysUtils,
  CompileU;

var
  VInputFileName  : String;
  VOutputFileName : String;

begin
  WriteLn('C-to-Quadcode Compiler');
  WriteLn('----------------------');
  WriteLn('Practical Work:');
  WriteLn('    Compilers Summer Semester 2008');
  WriteLn('    (Lecture by Mr. Schwinn)');
  WriteLn('');
  WriteLn('Course:');
  WriteLn('    TAI-06-ABC');
  WriteLn('');
  WriteLn('Developers:');
  WriteLn('   Kevin Niehage   (Matrikelnummer: 280888)');
  WriteLn('   Michaela Hansel (Matrikelnummer: 221664)');
  WriteLn('-------------------------------------------');
  WriteLn('');

  if (ParamCount > 0) then
  begin
    VInputFileName := ParamStr(1);
    if (ParamCount > 1) then
      VOutputFileName := ParamStr(2)
    else
      VOutputFileName := ChangeFileExt(VInputFileName, '.out');

    Compile(VInputFileName, VOutputFileName);
  end
  else
  begin
    WriteLn('Please provide an input filename:');
    WriteLn('> ' + ExtractFileName(ParamStr(0)) + ' INPUTFILE [OUTPUTFILE]');
  end;
end.
