unit ConstsU;

(*
//  C-to-Quadcode Compiler
//  ----------------------
//  Practical Work:
//      Compilers Summer Semester 2008
//      (Lecture by Mr. Schwinn)
//
//  Course:
//      TAI-06-ABC
//
//  Developers:
//     Kevin Niehage   (Matrikelnummer: 280888)
//     Michaela Hansel (Matrikelnummer: 221664)
*)

// IMPLEMENTATION STATUS: DONE

interface

const // Errors
  CErrorAssignmentOnNoVariable                  = 'An assignment on a non-variable has been encountered. ';
  CErrorAssignmentWithPrecedingOperation        = 'An assignment with a preceding operation has been encountered. ';
  CErrorBinaryOperationWithoutOperand           = 'A binary operation without a left operand has been encountered. ';
  CErrorBracketCountMismatch                    = 'A bracket count mismatch has been encountered. ';
  CErrorDoWithoutExpression                     = 'A DO operation without an expression has been encountered. ';
  CErrorDuplicateFunctionDefinition             = 'A duplicate function definition has been encountered. ';
  CErrorDuplicateFunctionForward                = 'A duplicate function forward has been encountered. ';
  CErrorDuplicateIncOperation                   = 'A duplicate increment operation has been encountered. ';
  CErrorEmptyReturnExpression                   = 'An empty return expression has been encountered. ';
  CErrorFunctionDefinitionDoesNotMatchForward   = 'A function forward/definition mismatch has been encountered. ';
  CErrorFunctionForwardAfterDefinition          = 'A function forward has been encountered after its definition. ';
  CErrorGlobalVariableWithoutConstantValue      = 'A global variable definition without a constant value has been encountered. ';
  CErrorHelperCountMismatch                     = 'A helper count mismatch has been encountered. ';
  CErrorIdentifierAlreadyDefined                = 'An already defined identifier has been encountered. ';
  CErrorIfWithoutExpression                     = 'An IF operation without an expression has been encountered. ';
  CErrorIncrementOnNoInteger                    = 'An increment on a non-integer value has been encountered. ';
  CErrorIncrementOnNoVariable                   = 'An increment on a non-variable has been encountered. ';
  CErrorInvalidOperationEvaluation              = 'An invalid operation evaluation has been encountered. ';
  CErrorModuloOnNoInteger                       = 'A MOD operation with non-integer operators has been encountered. ';
  CErrorNoEnding                                = 'No statement ending has been encountered. ';
  CErrorNoFunctionDefinition                    = 'No function definition has been encountered. ';
  CErrorNoIntMainFunction                       = 'A main function that is not of type "int" has been encountered. ';
  CErrorNoMainFunction                          = 'No main function has been encountered. ';
  CErrorNoQuoteEnding                           = 'No quote ending has been encountered. ';
  CErrorParamTypeMismatch                       = 'A parameter type mismatch has been encountered. ';
  CErrorReservedWordAsIdentifier                = 'A reserved word has been encountered as an identifier. ';
  CErrorReturnExpressionForVoid                 = 'A return expression for a void function has been encountered. ';
  CErrorShiftOnNoInteger                        = 'A SHIFT operation with non-integer operators has been encountered. ';
  CErrorTypeMismatch                            = 'A type mismatch has been encountered. ';
  CErrorUnaryOperationWithOperand               = 'A unary operation with a left operand has been encountered. ';
  CErrorUnaryOperationWithWrongNumberOfOperands = 'A unary operation with an incorrect number of operands has been encountered. ';
  CErrorUnknownCharacter                        = 'An unknown character has been encountered. ';
  CErrorUnknownNameCharacter                    = 'An unknown name identifier character has been encountered. ';
  CErrorUnknownOperand                          = 'An unknown operand has been encountered. ';
  CErrorUnknownSymbol                           = 'An unknown symbol has been encountered. ';
  CErrorUnknownSymbolType                       = 'An unknown symbol type has been encountered. ';
  CErrorUnknownTypeCharacter                    = 'An unknown type identifier character has been encountered. ';
  CErrorUnknownValueCharacter                   = 'An unknown value identifier character has been encountered. ';
  CErrorUnknownVariableType                     = 'An unknown variable type has been encountered. ';
  CErrorUnsupportedOperation                    = 'An unsupported operation has been encountered. ';
  CErrorUnsupportedParametersForMain            = 'Unsupported parameter(s) for function main has/have been encountered. ';
  CErrorVoidVariable                            = 'A variable of type void has been encountered. ';
  CErrorWhileWithoutExpression                  = 'A WHILE operation without an expression has been encountered. ';

const // C
  CCBool   = 'bool';
  CCConst  = 'const';
  CCDo     = 'do';
  CCElse   = 'else';
  CCFloat  = 'float';
  CCIf     = 'if';
  CCInt    = 'int';
  CCMain   = 'main';
  CCReturn = 'return';
  CCVoid   = 'void';
  CCWhile  = 'while';

const // Quad
  CQuadBool  = 'Bool';
  CQuadFalse = 'FALSE';
  CQuadFunc  = 'Func';
  CQuadInt   = 'Int';
  CQuadNone  = 'None';
  CQuadPrg   = 'Prg';
  CQuadProc  = 'Proc';
  CQuadReal  = 'Real';
  CQuadTrue  = 'TRUE';

const // Generate
  CIntHelper  = '_IH';
  CRealHelper = '_RH';

implementation

end.
