unit ErrorsU;

(*
//  C-to-Quadcode Compiler
//  ----------------------
//  Practical Work:
//      Compilers Summer Semester 2008
//      (Lecture by Mr. Schwinn)
//
//  Course:
//      TAI-06-ABC
//
//  Developers:
//     Kevin Niehage   (Matrikelnummer: 280888)
//     Michaela Hansel (Matrikelnummer: 221664)
*)

// IMPLEMENTATION STATUS: DONE

interface

uses
  SysUtils,
  ConstsU;

function BuildParseError(const AInput : String; const ANext : Char; const ABuffer : String; const ABufferCount : LongInt; const AErrorText : String) : String;

implementation

function BuildParseError(const AInput : String; const ANext : Char; const ABuffer : String; const ABufferCount : LongInt; const AErrorText : String) : String;
begin
  Result := 'Error         : ' + #34 + AErrorText + #34 + sLineBreak +
            'Next Char     : ' + #34 + ANext + #34 + sLineBreak +
            'Current Buffer: ' + #34 + Copy(ABuffer, 1 , ABufferCount) + #34 + sLineBreak +
            '>>' + sLineBreak +
            AInput + sLineBreak +
            '<<';
end;

end.
