unit SwitchesU;

(*
//  C-to-Quadcode Compiler
//  ----------------------
//  Practical Work:
//      Compilers Summer Semester 2008
//      (Lecture by Mr. Schwinn)
//
//  Course:
//      TAI-06-ABC
//
//  Developers:
//     Kevin Niehage   (Matrikelnummer: 280888)
//     Michaela Hansel (Matrikelnummer: 221664)
*)

// IMPLEMENTATION STATUS: DONE

interface

uses
  ErrorsU,
  TypesU;

function KillSwitches(const ASource : String) : String;

implementation

function KillSwitches(const ASource : String) : String;
var
  LCount  : LongInt;
  LIndex  : LongInt;
  LNext   : Char;
  LStatus : TSwitchStatus;
begin
  SetLength(Result, Length(ASource));
  LCount  := 0;

//  LNext   := #0;
  LStatus := ssWaitForSwitch;
  
  for LIndex := 1 to Length(ASource) do
  begin
    LNext := ASource[LIndex];

    case LStatus of
      ssWaitForSwitch :
      begin
        case LNext of
          '#' :
          begin
            LStatus := ssSwitch;
          end;
        else
          Inc(LCount);
          Result[LCount] := LNext;
        end;
      end;

      ssSwitch :
      begin
        case LNext of
          #10, #13 :
          begin
            Inc(LCount);
            Result[LCount] := LNext;

            LStatus := ssWaitForSwitch;
          end;
        end;
      end;
    end;
  end;

  SetLength(Result, LCount);
end;

end.

